import os
import sys
import time
import datetime
import mysql.connector
from xlrd import open_workbook

import tkinter as tk
from tkinter import filedialog

import default_setting

# Create a Tkinter root window (it won't be shown)
root = tk.Tk()
root.withdraw()  # Hide the root window

# Get Current Path
dir_path = os.path.dirname(os.path.realpath(__file__))

def formatDate(date):
    if ((date == None) or (len(date) < 14)):
        date = "0001-01-01 00:00:01"
    else:
        dd = date[0:2]
        mm = date[3:5]
        yy = date[6:8]
        tm = date[9:14]
        date = '20'+yy+"-"+mm+"-"+dd+" "+tm+":00"
    return date
        
def inventory_master(connection,data):
    try:
        cursor = connection.cursor(dictionary=True)
        try:
            dataQuery = "SELECT id FROM location WHERE location_code='"+str(data[3]).strip()+"' LIMIT 1"
            cursor.execute(dataQuery) 
            row = cursor.fetchone()
            if (row):
                locId = row['id']
            else:
                locId = None
            partNumber = data[0].strip()
            serialReference = data[1].strip()
            dataQuery = "SELECT id FROM part WHERE part_number='"+partNumber+"' LIMIT 1"
            cursor.execute(dataQuery) 
            row = cursor.fetchone()
            if (row):
                partId = row['id']
            else:
                partId = None
            dataQuery = "SELECT id FROM inventory_master WHERE part_number='"+partNumber+"' AND serial_reference='"+serialReference+"' LIMIT 1"
            cursor.execute(dataQuery) 
            row = cursor.fetchone()
            if (row):
                invId = row['id']
            else:
                invId = None
            if (invId == None):
                dataQuery = "INSERT INTO inventory_master (id,version,allocated_qty,hold_qty,current_inventory_status_id,current_location_id,location_id,location_code,date_created,created_by,expiry_date,inventory_qty,available_qty,last_updated,last_updated_by,parent_tag_id,part_id,part_number,ran_or_order,recorded_missing,requires_decant,requires_inspection,serial_reference,originating_detail_id,conversion_factor,stock_date,active,inventory_status_id,product_type_id)" 
                dataQuery += " VALUES(DEFAULT,0,0,0,null,"
                if (locId != None):
                    dataQuery +=str(locId)+","+str(locId)+",'"
                else:
                    dataQuery +="null,null,'"
                dataQuery += str(data[3]).strip()+"',now(),'upload',null,"+str(data[2]).strip()+","+str(data[2]).strip()+",now(),'upload',null,"+str(partId)+",'"+partNumber+"',null,0,0,0,'"+serialReference+"',null,1,now(),1,1,null)"
                cursor.execute(dataQuery)
                connection.commit()
        except Exception as e:
#            print ('Update Error',str(e),dataQuery)
            pass
    except Exception as e:
#        print("FAIL-",str(e),dataQuery)
        pass
    finally:
       cursor.close()
#    print("TEST4")
    return
    
# timestamp value   
def getts():
    ts = time.time()
    ts = datetime.datetime.fromtimestamp(ts).strftime('_%Y%m%d_%H%M%S')
    return ts

def connection():
    dbhost = ""
    if (len(sys.argv) > 1):
        dbhost = sys.argv[1]
    if (len(sys.argv) > 2):
        dbuser = sys.argv[2]
    if (len(sys.argv) > 3):
        dbpwd = sys.argv[3]
    if (len(sys.argv) > 4):
        dbase = sys.argv[4]
# mySql Connector
    if (len(sys.argv) > 1):
        connection = mysql.connector.connect(user=dbuser, password=dbpwd,host=dbhost,database=dbase)
    else:
# Default Connection / System Settings
        defaults = default_setting.defaultSettings()
        connection = mysql.connector.connect(user=defaults['dbuser'], password=defaults['dbpwd'],host=defaults['dbhost'],database=defaults['dbase'])
        
    return connection

def main():
    try:
        connect = connection()
        
        if (len(sys.argv) > 5):
            file_path = sys.argv[5]
        else:
# Prompt the user to select a file
            file_path = filedialog.askopenfilename(title="Select a file")
# Check if a file was selected
            if file_path:
                print(f"Selected file: {file_path}")
            else:
                print("No file selected.")
                file_path = "F:/kukfiles/adhoc/zone upload.xlsx"
        
        file_path_xls = file_path
        
        if os.path.isfile(file_path_xls):
            wb = open_workbook(file_path_xls)
    
# Loop through the Sheets
            for s in wb.sheets():
#                print('Sheet:', s.name)
                data = []  # Initialize data for each sheet
                
# Loop through the Sheet Rows
                for row in range(s.nrows):
#                    print("Row:", row)
                    row_data = []
                    
                    for col in range(s.ncols):  # Loop through columns
                        try:
                            value = s.cell(row, col).value
                            if isinstance(value, (int, float)):  # Check if value is a number
                                row_data.append(str(int(value)))
                            else:
                                row_data.append(str(value))  # Convert to string directly
                        except ValueError:
                            row_data.append("")  # Handle conversion errors
                        except Exception as e:
                            print(f"Error processing cell ({row}, {col}): {e}")
                    
# data.append(row_data)  # Append the row data to the main data list
                    try:
                        inventory_master(connect,row_data)
                    except Exception as e:
                        print("data error:",str(row_data))
                        pass
        else:
            print ("FAIL-upload File "+file_path_xls+" not found")
            return
        print ("OK  -Upload Complete "+file_path)
    except Exception as e:
        print ("FAIL-1-",str(e))
if __name__ == '__main__':
    main()